diff --git a/oflog/libsrc/logevent.cc b/oflog/libsrc/logevent.cc
index c15000c..5a0ff6d 100644
--- a/oflog/libsrc/logevent.cc
+++ b/oflog/libsrc/logevent.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -19,19 +19,109 @@
 // limitations under the License.
 
 #include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/internal/internal.h"
+#include <algorithm>
 
 
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::spi;
+namespace dcmtk {
+namespace log4cplus {  namespace spi {
 
 
-#define DCMTK_LOG4CPLUS_DEFAULT_TYPE 1
+static const int DCMTK_LOG4CPLUS_DEFAULT_TYPE = 1;
 
 
 ///////////////////////////////////////////////////////////////////////////////
-// InternalLoggingEvent dtor
+// InternalLoggingEvent ctors and dtor
 ///////////////////////////////////////////////////////////////////////////////
 
+InternalLoggingEvent::InternalLoggingEvent(const log4cplus::tstring& logger,
+    LogLevel loglevel, const log4cplus::tstring& message_, const char* filename,
+    int line_)
+    : message(message_)
+    , loggerName(logger)
+    , ll(loglevel)
+    , ndc()
+    , mdc()
+    , thread()
+    , thread2()
+    , timestamp(log4cplus::helpers::Time::gettimeofday())
+    , file(filename
+        ? DCMTK_LOG4CPLUS_C_STR_TO_TSTRING(filename) 
+        : log4cplus::tstring())
+    , function ()
+    , line(line_)
+    , threadCached(false)
+    , thread2Cached(false)
+    , ndcCached(false)
+    , mdcCached(false)
+{
+}
+
+
+InternalLoggingEvent::InternalLoggingEvent(const log4cplus::tstring& logger,
+    LogLevel loglevel, const log4cplus::tstring& ndc_,
+    MappedDiagnosticContextMap const & mdc_, const log4cplus::tstring& message_,
+    const log4cplus::tstring& thread_, log4cplus::helpers::Time time,
+    const log4cplus::tstring& file_, int line_)
+    : message(message_)
+    , loggerName(logger)
+    , ll(loglevel)
+    , ndc(ndc_)
+    , mdc(mdc_)
+    , thread(thread_)
+    , thread2()
+    , timestamp(time)
+    , file(file_)
+    , function ()
+    , line(line_)
+    , threadCached(true)
+    , thread2Cached(true)
+    , ndcCached(true)
+    , mdcCached(true)
+{
+}
+
+
+InternalLoggingEvent::InternalLoggingEvent ()
+    : message()
+    , loggerName()
+    , ll (NOT_SET_LOG_LEVEL)
+    , ndc()
+    , mdc()
+    , thread()
+    , thread2()
+    , timestamp()
+    , file()
+    , function ()
+    , line(0)
+    , threadCached(false)
+    , thread2Cached(false)
+    , ndcCached(false)
+    , mdcCached(false)
+{ }
+
+
+InternalLoggingEvent::InternalLoggingEvent(
+    const log4cplus::spi::InternalLoggingEvent& rhs)
+    : message(rhs.getMessage())
+    , loggerName(rhs.getLoggerName())
+    , ll(rhs.getLogLevel())
+    , ndc(rhs.getNDC())
+    , mdc(rhs.getMDCCopy())
+    , thread(rhs.getThread())
+    , thread2(rhs.getThread2())
+    , timestamp(rhs.getTimestamp())
+    , file(rhs.getFile())
+    , function(rhs.getFunction())
+    , line(rhs.getLine())
+    , threadCached(true)
+    , thread2Cached(true)
+    , ndcCached(true)
+    , mdcCached(true)
+{
+}
+
+
 InternalLoggingEvent::~InternalLoggingEvent()
 {
 }
@@ -54,7 +144,49 @@ InternalLoggingEvent::getDefaultType()
 // InternalLoggingEvent implementation
 ///////////////////////////////////////////////////////////////////////////////
 
-const tstring&
+void
+InternalLoggingEvent::setLoggingEvent (const log4cplus::tstring & logger,
+    LogLevel loglevel, const log4cplus::tstring & msg, const char * filename,
+    int fline)
+{
+    // This could be imlemented using the swap idiom:
+    //
+    // InternalLoggingEvent (logger, loglevel, msg, filename, fline).swap (*this);
+    //
+    // But that defeats the optimization of using thread local instance
+    // of InternalLoggingEvent to avoid memory allocation.
+
+    loggerName = logger;
+    ll = loglevel;
+    message = msg;
+    timestamp = helpers::Time::gettimeofday();
+    if (filename)
+        file = DCMTK_LOG4CPLUS_C_STR_TO_TSTRING (filename);
+    else
+        file.clear ();
+    line = fline;
+    threadCached = false;
+    thread2Cached = false;
+    ndcCached = false;
+    mdcCached = false;
+}
+
+
+void
+InternalLoggingEvent::setFunction (char const * func)
+{
+    function = DCMTK_LOG4CPLUS_C_STR_TO_TSTRING (func);
+}
+
+
+void
+InternalLoggingEvent::setFunction (log4cplus::tstring const & func)
+{
+    function = func;
+}
+
+
+const log4cplus::tstring& 
 InternalLoggingEvent::getMessage() const
 {
     return message;
@@ -77,25 +209,57 @@ InternalLoggingEvent::clone() const
 }
 
 
-
-InternalLoggingEvent&
-InternalLoggingEvent::operator=(const InternalLoggingEvent& rhs)
+tstring const &
+InternalLoggingEvent::getMDC (tstring const & key) const
 {
-    if(this == &rhs) return *this;
-
-    message = rhs.message;
-    loggerName = rhs.loggerName;
-    ll = rhs.ll;
-    ndc = rhs.getNDC();
-    thread = rhs.getThread();
-    timestamp = rhs.timestamp;
-    file = rhs.file;
-    function = rhs.function;
-    line = rhs.line;
-    threadCached = true;
-    ndcCached = true;
+    MappedDiagnosticContextMap const & mdc_ = getMDCCopy ();
+    MappedDiagnosticContextMap::const_iterator it = mdc_.find (key);
+    if (it != mdc_.end ())
+        return it->second;
+    else
+        return internal::empty_str;
+}
+
+
 
+InternalLoggingEvent &
+InternalLoggingEvent::operator = (const InternalLoggingEvent& rhs)
+{
+    InternalLoggingEvent (rhs).swap (*this);
     return *this;
 }
 
 
+void
+InternalLoggingEvent::gatherThreadSpecificData () const
+{
+    getNDC ();
+    getMDCCopy ();
+    getThread ();
+    getThread2 ();
+}
+
+
+void
+InternalLoggingEvent::swap (InternalLoggingEvent & other)
+{
+    using STD_NAMESPACE swap;
+
+    swap (message, other.message);
+    swap (loggerName, other.loggerName);
+    swap (ll, other.ll);
+    swap (ndc, other.ndc);
+    swap (mdc, other.mdc);
+    swap (thread, other.thread);
+    swap (thread2, other.thread2);
+    swap (timestamp, other.timestamp);
+    swap (file, other.file);
+    swap (function, other.function);
+    swap (line, other.line);
+    swap (threadCached, other.threadCached);
+    swap (ndcCached, other.ndcCached);
+}
+
+
+} } // namespace log4cplus {  namespace spi {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/logger.cc b/oflog/libsrc/logger.cc
index b02d973..ea07d91 100644
--- a/oflog/libsrc/logger.cc
+++ b/oflog/libsrc/logger.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -23,21 +23,20 @@
 #include "dcmtk/oflog/hierarchy.h"
 #include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/spi/logimpl.h"
+#include <utility>
 
-using namespace dcmtk::log4cplus::spi;
 
 namespace dcmtk
 {
-
 namespace log4cplus
 {
 
 
-Logger
-DefaultLoggerFactory::makeNewLoggerInstance (const tstring & name,
+Logger 
+DefaultLoggerFactory::makeNewLoggerInstance (const log4cplus::tstring & name,
     Hierarchy& h)
-{
-    return Logger (new LoggerImpl (name, h));
+{ 
+    return Logger (new spi::LoggerImpl (name, h));
 }
 
 
@@ -45,55 +44,53 @@ DefaultLoggerFactory::makeNewLoggerInstance (const tstring & name,
 // static Logger Methods
 //////////////////////////////////////////////////////////////////////////////
 //
-Hierarchy &
+Hierarchy & 
 Logger::getDefaultHierarchy ()
 {
-    static Hierarchy defaultHierarchy;
-
-    return defaultHierarchy;
+    return log4cplus::getDefaultHierarchy ();
 }
 
 
-bool
-Logger::exists (const tstring & name)
+bool 
+Logger::exists (const log4cplus::tstring & name) 
 {
-    return getDefaultHierarchy().exists(name);
+    return getDefaultHierarchy().exists(name); 
 }
 
 
 LoggerList
-Logger::getCurrentLoggers ()
+Logger::getCurrentLoggers () 
 {
     return getDefaultHierarchy ().getCurrentLoggers ();
 }
 
 
-Logger
-Logger::getInstance (const tstring& name)
-{
-    return getDefaultHierarchy().getInstance(name);
+Logger 
+Logger::getInstance (const log4cplus::tstring& name) 
+{ 
+    return getDefaultHierarchy().getInstance(name); 
 }
 
 
-Logger
-Logger::getInstance (const tstring& name,
-    LoggerFactory& factory)
-{
-    return getDefaultHierarchy().getInstance(name, factory);
+Logger 
+Logger::getInstance (const log4cplus::tstring& name,
+    spi::LoggerFactory& factory)
+{ 
+    return getDefaultHierarchy().getInstance(name, factory); 
 }
 
 
-Logger
-Logger::getRoot ()
-{
-    return getDefaultHierarchy ().getRoot ();
+Logger 
+Logger::getRoot () 
+{ 
+    return getDefaultHierarchy ().getRoot (); 
 }
 
 
-void
-Logger::shutdown ()
-{
-    getDefaultHierarchy ().shutdown ();
+void 
+Logger::shutdown () 
+{ 
+    getDefaultHierarchy ().shutdown (); 
 }
 
 
@@ -107,7 +104,7 @@ Logger::Logger ()
 { }
 
 
-Logger::Logger (LoggerImpl * ptr)
+Logger::Logger (spi::LoggerImpl * ptr)
     : value (ptr)
 {
     if (value)
@@ -116,7 +113,7 @@ Logger::Logger (LoggerImpl * ptr)
 
 
 Logger::Logger (const Logger& rhs)
-    : AppenderAttachable (rhs)
+    : spi::AppenderAttachable (rhs)
     , value (rhs.value)
 {
     if (value)
@@ -132,7 +129,26 @@ Logger::operator = (const Logger& rhs)
 }
 
 
-Logger::~Logger ()
+#if defined (DCMTK_LOG4CPLUS_HAVE_RVALUE_REFS)
+Logger::Logger (Logger && rhs)
+    : spi::AppenderAttachable (STD_NAMESPACE move (rhs))
+    , value (STD_NAMESPACE move (rhs.value))
+{
+    rhs.value = 0;
+}
+
+
+Logger &
+Logger::operator = (Logger && rhs)
+{
+    Logger (STD_NAMESPACE move (rhs)).swap (*this);
+    return *this;
+}
+
+#endif
+
+
+Logger::~Logger () 
 {
     if (value)
         value->removeReference ();
@@ -146,70 +162,71 @@ Logger::~Logger ()
 void
 Logger::swap (Logger & other)
 {
-    LoggerImpl* tmp = value;
-    value = other.value;
-    other.value = tmp;
-    //STD_NAMESPACE swap (value, other.value);
+    spi::LoggerImpl * tmp = other.value;
+    other.value = value;
+    value = tmp;
 }
 
 
 Logger
-Logger::getParent () const
+Logger::getParent () const 
 {
     if (value->parent)
         return Logger (value->parent.get ());
     else
     {
-        value->getLogLog().error(DCMTK_LOG4CPLUS_TEXT("********* This logger has no parent: " + getName()));
+        helpers::getLogLog().error(
+            DCMTK_LOG4CPLUS_TEXT("********* This logger has no parent: "
+            + getName()));
         return *this;
     }
 }
 
 
-void
+void 
 Logger::addAppender (SharedAppenderPtr newAppender)
 {
     value->addAppender(newAppender);
 }
 
 
-SharedAppenderPtrList
+SharedAppenderPtrList 
 Logger::getAllAppenders ()
 {
     return value->getAllAppenders();
 }
 
 
-SharedAppenderPtr
-Logger::getAppender (const tstring& name)
+SharedAppenderPtr 
+Logger::getAppender (const log4cplus::tstring& name)
 {
     return value->getAppender (name);
 }
 
 
-void
+void 
 Logger::removeAllAppenders ()
 {
     value->removeAllAppenders ();
 }
 
 
-void
+void 
 Logger::removeAppender (SharedAppenderPtr appender)
 {
     value->removeAppender(appender);
 }
 
 
-void
-Logger::removeAppender (const tstring& name)
+void 
+Logger::removeAppender (const log4cplus::tstring& name)
 {
     value->removeAppender (name);
 }
 
 
 void
-Logger::assertion (bool assertionVal, const tstring& msg) const
+Logger::assertion (bool assertionVal, const log4cplus::tstring& msg) const
 {
     if (! assertionVal)
         log (FATAL_LOG_LEVEL, msg);
@@ -231,23 +248,37 @@ Logger::isEnabledFor (LogLevel ll) const
 
 
 void
-Logger::log (LogLevel ll, const tstring& message, const char* file,
-    int line, const char* function) const
+Logger::log (LogLevel ll, const log4cplus::tstring& message, const char* file,
+    int line) const
 {
-    value->log (ll, message, file, line, function);
+    value->log (ll, message, file, line);
 }
 
 
 void
-Logger::forcedLog (LogLevel ll, const tstring& message,
-    const char* file, int line, const char* function) const
+Logger::log (spi::InternalLoggingEvent const & ev) const
 {
-    value->forcedLog (ll, message, file, line, function);
+    value->log (ev);
 }
 
 
 void
-Logger::callAppenders (const InternalLoggingEvent& event) const
+Logger::forcedLog (LogLevel ll, const log4cplus::tstring& message,
+    const char* file, int line) const
+{
+    value->forcedLog (ll, message, file, line);
+}
+
+
+void
+Logger::forcedLog (spi::InternalLoggingEvent const & ev) const
+{
+    value->forcedLog (ev);
+}
+
+
+void
+Logger::callAppenders (const spi::InternalLoggingEvent& event) const
 {
     value->callAppenders (event);
 }
@@ -276,12 +307,12 @@ Logger::setLogLevel (LogLevel ll)
 
 Hierarchy &
 Logger::getHierarchy () const
-{
+{ 
     return value->getHierarchy ();
 }
 
 
-tstring
+log4cplus::tstring const &
 Logger::getName () const
 {
     return value->getName ();
@@ -297,11 +328,10 @@ Logger::getAdditivity () const
 
 void
 Logger::setAdditivity (bool additive)
-{
+{ 
     value->setAdditivity (additive);
 }
 
 
 } // namespace log4cplus
-
-} // namespace dcmtk
+} // end namespace dcmtk
diff --git a/oflog/libsrc/logimpl.cc b/oflog/libsrc/logimpl.cc
index 1be5084..35df6bc 100644
--- a/oflog/libsrc/logimpl.cc
+++ b/oflog/libsrc/logimpl.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -18,35 +18,34 @@
 // See the License for the specific language governing permissions and
 // limitations under the License.
 
+#include "dcmtk/oflog/internal/internal.h"
 #include "dcmtk/oflog/spi/logimpl.h"
 #include "dcmtk/oflog/appender.h"
 #include "dcmtk/oflog/hierarchy.h"
 #include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/spi/logevent.h"
 #include "dcmtk/oflog/spi/rootlog.h"
-//#include <stdexcept>
-
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
-using namespace dcmtk::log4cplus::spi;
+#include "dcmtk/oflog/thread/syncpub.h"
 
 
+namespace dcmtk {
+namespace log4cplus { namespace spi {
 
 //////////////////////////////////////////////////////////////////////////////
 // Logger Constructors and Destructor
 //////////////////////////////////////////////////////////////////////////////
-LoggerImpl::LoggerImpl(const tstring& name_, Hierarchy& h)
+LoggerImpl::LoggerImpl(const log4cplus::tstring& name_, Hierarchy& h)
   : name(name_),
     ll(NOT_SET_LOG_LEVEL),
     parent(NULL),
-    additive(true),
+    additive(true), 
     hierarchy(h)
 {
 }
 
 
-LoggerImpl::~LoggerImpl()
-{
+LoggerImpl::~LoggerImpl() 
+{ 
 }
 
 
@@ -54,7 +53,7 @@ LoggerImpl::~LoggerImpl()
 // Logger Methods
 //////////////////////////////////////////////////////////////////////////////
 
-void
+void 
 LoggerImpl::callAppenders(const InternalLoggingEvent& event)
 {
     int writes = 0;
@@ -67,51 +66,59 @@ LoggerImpl::callAppenders(const InternalLoggingEvent& event)
 
     // No appenders in hierarchy, warn user only once.
     if(!hierarchy.emittedNoAppenderWarning && writes == 0) {
-        getLogLog().error(  DCMTK_LOG4CPLUS_TEXT("No appenders could be found for logger (")
-                          + getName()
-                          + DCMTK_LOG4CPLUS_TEXT(")."));
-        getLogLog().error(DCMTK_LOG4CPLUS_TEXT("Please initialize the log4cplus system properly."));
+        helpers::getLogLog().error(
+            DCMTK_LOG4CPLUS_TEXT("No appenders could be found for logger (") 
+            + getName() 
+            + DCMTK_LOG4CPLUS_TEXT(")."));
+        helpers::getLogLog().error(
+            DCMTK_LOG4CPLUS_TEXT("Please initialize the log4cplus system properly."));
         hierarchy.emittedNoAppenderWarning = true;
     }
 }
 
 
-void
+void 
 LoggerImpl::closeNestedAppenders()
 {
     SharedAppenderPtrList appenders = getAllAppenders();
-    for(SharedAppenderPtrListIterator it=appenders.begin(); it!=appenders.end(); ++it)
+    for(SharedAppenderPtrList::iterator it=appenders.begin(); it!=appenders.end(); ++it)
     {
         (*it)->close();
     }
 }
 
 
-bool
-LoggerImpl::isEnabledFor(LogLevel ll_) const
+bool 
+LoggerImpl::isEnabledFor(LogLevel loglevel) const
 {
-    if(hierarchy.disableValue >= ll_) {
+    if(hierarchy.disableValue >= loglevel) {
         return false;
     }
-    return ll_ >= getChainedLogLevel();
+    return loglevel >= getChainedLogLevel();
 }
 
 
-void
-LoggerImpl::log(LogLevel ll_,
-                const tstring& message,
-                const char* file,
-                int line,
-                const char* function)
+void 
+LoggerImpl::log(LogLevel loglevel, 
+                const log4cplus::tstring& message,
+                const char* file, 
+                int line)
 {
-    if(isEnabledFor(ll_)) {
-        forcedLog(ll_, message, file, line, function);
+    if(isEnabledFor(loglevel)) {
+        forcedLog(loglevel, message, file, line);
     }
 }
 
 
+void 
+LoggerImpl::log(spi::InternalLoggingEvent const & ev)
+{
+    if (isEnabledFor(ev.getLogLevel ()))
+        forcedLog(ev);
+}
+
 
-LogLevel
+LogLevel 
 LoggerImpl::getChainedLogLevel() const
 {
     for(const LoggerImpl *c=this; c != NULL; c=c->parent.get()) {
@@ -120,45 +127,52 @@ LoggerImpl::getChainedLogLevel() const
         }
     }
 
-    getLogLog().error( DCMTK_LOG4CPLUS_TEXT("LoggerImpl::getChainedLogLevel()- No valid LogLevel found") );
-    //throw STD_NAMESPACE runtime_error("No valid LogLevel found");
-
-    // This can only happen if the root logger is set to NOT_SET_LOG_LEVEL which
-    // should *never* happen. Let's just invent something in this case.
-    return TRACE_LOG_LEVEL;
+    helpers::getLogLog().error(
+        DCMTK_LOG4CPLUS_TEXT("LoggerImpl::getChainedLogLevel()- No valid LogLevel found"),
+        true);
+    return NOT_SET_LOG_LEVEL;
 }
 
 
-Hierarchy&
+Hierarchy& 
 LoggerImpl::getHierarchy() const
-{
-    return hierarchy;
+{ 
+    return hierarchy; 
 }
 
 
-bool
+bool 
 LoggerImpl::getAdditivity() const
-{
-    return additive;
+{ 
+    return additive; 
 }
 
 
-void
-LoggerImpl::setAdditivity(bool additive_)
-{
-    this->additive = additive_;
+void 
+LoggerImpl::setAdditivity(bool additive_) 
+{ 
+    additive = additive_; 
 }
 
 
-void
-LoggerImpl::forcedLog(LogLevel ll_,
-                      const tstring& message,
-                      const char* file,
-                      int line,
-                      const char* function)
+void 
+LoggerImpl::forcedLog(LogLevel loglevel,
+                      const log4cplus::tstring& message,
+                      const char* file, 
+                      int line)
 {
-    callAppenders(InternalLoggingEvent(this->getName(), ll_, message, file, line, function));
+    spi::InternalLoggingEvent & ev = internal::get_ptd ()->forced_log_ev;
+    ev.setLoggingEvent (this->getName(), loglevel, message, file, line);
+    callAppenders(ev);
 }
 
 
+void 
+LoggerImpl::forcedLog(spi::InternalLoggingEvent const & ev)
+{
+    callAppenders(ev);
+}
+
 
+} } // namespace log4cplus { namespace spi {
+} // end namespace dcmtk
diff --git a/oflog/libsrc/loglevel.cc b/oflog/libsrc/loglevel.cc
index 9618933..68838b7 100644
--- a/oflog/libsrc/loglevel.cc
+++ b/oflog/libsrc/loglevel.cc
@@ -4,7 +4,7 @@
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -21,201 +21,191 @@
 #include "dcmtk/oflog/loglevel.h"
 #include "dcmtk/oflog/helpers/loglog.h"
 #include "dcmtk/oflog/helpers/strhelp.h"
-//#include <algorithm>
+#include "dcmtk/oflog/internal/internal.h"
+#include <algorithm>
 
-using namespace dcmtk::log4cplus;
-using namespace dcmtk::log4cplus::helpers;
 
-#define _ALL_STRING DCMTK_LOG4CPLUS_TEXT("ALL")
-#define _TRACE_STRING DCMTK_LOG4CPLUS_TEXT("TRACE")
-#define _DEBUG_STRING DCMTK_LOG4CPLUS_TEXT("DEBUG")
-#define _INFO_STRING DCMTK_LOG4CPLUS_TEXT("INFO")
-#define _WARN_STRING DCMTK_LOG4CPLUS_TEXT("WARN")
-#define _ERROR_STRING DCMTK_LOG4CPLUS_TEXT("ERROR")
-#define _FATAL_STRING DCMTK_LOG4CPLUS_TEXT("FATAL")
-#define _OFF_STRING DCMTK_LOG4CPLUS_TEXT("OFF")
-#define _NOTSET_STRING DCMTK_LOG4CPLUS_TEXT("NOTSET")
-#define _UNKNOWN_STRING DCMTK_LOG4CPLUS_TEXT("UNKNOWN")
-
-#define GET_TO_STRING_NODE OFstatic_cast(ToStringNode*, this->toStringMethods)
-#define GET_FROM_STRING_NODE OFstatic_cast(FromStringNode*, this->fromStringMethods)
-
-
-
-//////////////////////////////////////////////////////////////////////////////
-// file LOCAL definitions
-//////////////////////////////////////////////////////////////////////////////
+namespace dcmtk
+{
+namespace log4cplus
+{
 
-namespace {
-    class ToStringNode {
-    public:
-        ToStringNode(LogLevelToStringMethod m) : method(m), next(0) {}
 
-        LogLevelToStringMethod method;
-        ToStringNode* next;
-    };
+namespace
+{
 
+static tstring const ALL_STRING (DCMTK_LOG4CPLUS_TEXT("ALL"));
+static tstring const TRACE_STRING (DCMTK_LOG4CPLUS_TEXT("TRACE"));
+static tstring const DEBUG_STRING (DCMTK_LOG4CPLUS_TEXT("DEBUG"));
+static tstring const INFO_STRING (DCMTK_LOG4CPLUS_TEXT("INFO"));
+static tstring const WARN_STRING (DCMTK_LOG4CPLUS_TEXT("WARN"));
+static tstring const ERROR_STRING (DCMTK_LOG4CPLUS_TEXT("ERROR"));
+static tstring const FATAL_STRING (DCMTK_LOG4CPLUS_TEXT("FATAL"));
+static tstring const OFF_STRING (DCMTK_LOG4CPLUS_TEXT("OFF"));
+static tstring const NOTSET_STRING (DCMTK_LOG4CPLUS_TEXT("NOTSET"));
+static tstring const UNKNOWN_STRING (DCMTK_LOG4CPLUS_TEXT("UNKNOWN"));
 
-    class FromStringNode {
-    public:
-        FromStringNode(StringToLogLevelMethod m) : method(m), next(0) {}
 
-        StringToLogLevelMethod method;
-        FromStringNode* next;
-    };
+struct log_levels_table_rec
+{
+    LogLevel ll;
+    tstring const * str;
+};
 
 
-    static
-    tstring
-    defaultLogLevelToStringMethod(LogLevel ll) {
-        switch(ll) {
-            case OFF_LOG_LEVEL:     return _OFF_STRING;
-            case FATAL_LOG_LEVEL:   return _FATAL_STRING;
-            case ERROR_LOG_LEVEL:   return _ERROR_STRING;
-            case WARN_LOG_LEVEL:    return _WARN_STRING;
-            case INFO_LOG_LEVEL:    return _INFO_STRING;
-            case DEBUG_LOG_LEVEL:   return _DEBUG_STRING;
-            case TRACE_LOG_LEVEL:   return _TRACE_STRING;
-            //case ALL_LOG_LEVEL:     return _ALL_STRING;
-            case NOT_SET_LOG_LEVEL: return _NOTSET_STRING;
-        };
-
-        return tstring();
-    }
+#define DEF_LLTAB_REC(x) { x ## _LOG_LEVEL, &(x ## _STRING) }
 
+static log_levels_table_rec const log_levels_table[8] = {
+    DEF_LLTAB_REC (OFF),
+    DEF_LLTAB_REC (FATAL),
+    DEF_LLTAB_REC (ERROR),
+    DEF_LLTAB_REC (WARN),
+    DEF_LLTAB_REC (INFO),
+    DEF_LLTAB_REC (DEBUG),
+    DEF_LLTAB_REC (TRACE),
+    DEF_LLTAB_REC (ALL),
+};
 
-    static
-    LogLevel
-    defaultStringToLogLevelMethod(const tstring& arg) {
-        tstring s = toUpper(arg);
+#undef DEF_LLTAB_REC
 
-        if(s == _ALL_STRING)   return ALL_LOG_LEVEL;
-        if(s == _TRACE_STRING) return TRACE_LOG_LEVEL;
-        if(s == _DEBUG_STRING) return DEBUG_LOG_LEVEL;
-        if(s == _INFO_STRING)  return INFO_LOG_LEVEL;
-        if(s == _WARN_STRING)  return WARN_LOG_LEVEL;
-        if(s == _ERROR_STRING) return ERROR_LOG_LEVEL;
-        if(s == _FATAL_STRING) return FATAL_LOG_LEVEL;
-        if(s == _OFF_STRING)   return OFF_LOG_LEVEL;
-
-        return NOT_SET_LOG_LEVEL;
-    }
 
+static
+tstring const &
+defaultLogLevelToStringMethod(LogLevel ll)
+{
+    switch(ll) {
+        case OFF_LOG_LEVEL:     return OFF_STRING;
+        case FATAL_LOG_LEVEL:   return FATAL_STRING;
+        case ERROR_LOG_LEVEL:   return ERROR_STRING;
+        case WARN_LOG_LEVEL:    return WARN_STRING;
+        case INFO_LOG_LEVEL:    return INFO_STRING;
+        case DEBUG_LOG_LEVEL:   return DEBUG_STRING;
+        case TRACE_LOG_LEVEL:   return TRACE_STRING;
+        //case ALL_LOG_LEVEL:     return ALL_STRING;
+        case NOT_SET_LOG_LEVEL: return NOTSET_STRING;
+    };
+    
+    return internal::empty_str;
 }
 
 
-
-//////////////////////////////////////////////////////////////////////////////
-// public static methods
-//////////////////////////////////////////////////////////////////////////////
-
-LogLevelManager&
-dcmtk::log4cplus::getLogLevelManager()
+static
+LogLevel
+defaultStringToLogLevelMethod(const tstring& s)
 {
-    static LogLevelManager singleton;
-    return singleton;
+    size_t const tbl_size
+        = sizeof (log_levels_table) / sizeof (log_levels_table[0]);
+
+    for (log_levels_table_rec const * it = log_levels_table;
+        it != log_levels_table + tbl_size; ++it)
+    {
+        if (*it->str == s)
+            return it->ll;
+    }
+    
+    return NOT_SET_LOG_LEVEL;
 }
 
+} // namespace
+
 
 
 //////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::LogLevelManager ctors and dtor
+// LogLevelManager ctors and dtor
 //////////////////////////////////////////////////////////////////////////////
 
-LogLevelManager::LogLevelManager()
-: toStringMethods(new ToStringNode(defaultLogLevelToStringMethod)),
-  fromStringMethods(new FromStringNode(defaultStringToLogLevelMethod))
+LogLevelManager::LogLevelManager() 
+    : toStringMethods(),
+      fromStringMethods()
 {
-}
-
+    LogLevelToStringMethodRec rec;
+    rec.func = defaultLogLevelToStringMethod;
+    rec.use_1_0 = false;
+    toStringMethods.push_back (rec);
 
+    fromStringMethods.push_back (&defaultStringToLogLevelMethod);
+}
 
-LogLevelManager::~LogLevelManager()
-{
-    ToStringNode* toStringTmp = GET_TO_STRING_NODE;
-    while(toStringTmp) {
-        ToStringNode* tmp = toStringTmp;
-        toStringTmp = toStringTmp->next;
-        delete tmp;
-    }
 
-    FromStringNode* fromStringTmp = GET_FROM_STRING_NODE;
-    while(fromStringTmp) {
-        FromStringNode* tmp = fromStringTmp;
-        fromStringTmp = fromStringTmp->next;
-        delete tmp;
-    }
-}
+LogLevelManager::~LogLevelManager() 
+{ }
 
 
 
 //////////////////////////////////////////////////////////////////////////////
-// dcmtk::log4cplus::LogLevelManager public methods
+// LogLevelManager public methods
 //////////////////////////////////////////////////////////////////////////////
 
-tstring
+tstring const &
 LogLevelManager::toString(LogLevel ll) const
 {
-    ToStringNode* toStringTmp = GET_TO_STRING_NODE;
-    while(toStringTmp) {
-        tstring ret = toStringTmp->method(ll);
-        if(ret.length() > 0) {
-            return ret;
+    tstring const * ret;
+    for (LogLevelToStringMethodList::const_iterator it
+        = toStringMethods.begin (); it != toStringMethods.end (); ++it)
+    {
+        LogLevelToStringMethodRec const & rec = *it;
+        if (rec.use_1_0)
+        {
+            // Use TLS to store the result to allow us to return
+            // a reference.
+            tstring & ll_str = internal::get_ptd ()->ll_str;
+            rec.func_1_0 (ll).swap (ll_str);
+            ret = &ll_str;
         }
-        toStringTmp = toStringTmp->next;
+        else
+            ret = &rec.func (ll);
+
+        if (! ret->empty ())
+            return *ret;
     }
 
-    return _UNKNOWN_STRING;
+    return UNKNOWN_STRING;
 }
 
 
-
-LogLevel
-LogLevelManager::fromString(const tstring& s) const
+LogLevel 
+LogLevelManager::fromString(const tstring& arg) const
 {
-    FromStringNode* fromStringTmp = GET_FROM_STRING_NODE;
-    while(fromStringTmp) {
-        LogLevel ret = fromStringTmp->method(s);
-        if(ret != NOT_SET_LOG_LEVEL) {
+    tstring s = helpers::toUpper(arg);
+
+    for (StringToLogLevelMethodList::const_iterator it
+        = fromStringMethods.begin (); it != fromStringMethods.end (); ++it)
+    {
+        LogLevel ret = (*it) (s);
+        if (ret != NOT_SET_LOG_LEVEL)
             return ret;
-        }
-        fromStringTmp = fromStringTmp->next;
     }
-
+    
     return NOT_SET_LOG_LEVEL;
 }
 
 
-
-void
+void 
 LogLevelManager::pushToStringMethod(LogLevelToStringMethod newToString)
 {
-    ToStringNode* toStringTmp = GET_TO_STRING_NODE;
-    while(1) {
-        if(toStringTmp->next) {
-            toStringTmp = toStringTmp->next;
-        }
-        else {
-            toStringTmp->next = new ToStringNode(newToString);
-            break;
-        }
-    }
+    LogLevelToStringMethodRec rec;
+    rec.func = newToString;
+    rec.use_1_0 = false;
+    toStringMethods.push_back (rec);
 }
 
 
+void 
+LogLevelManager::pushToStringMethod(LogLevelToStringMethod_1_0 newToString)
+{
+    LogLevelToStringMethodRec rec;
+    rec.func_1_0 = newToString;
+    rec.use_1_0 = true;
+    toStringMethods.push_back (rec);
+}
+
 
-void
+void 
 LogLevelManager::pushFromStringMethod(StringToLogLevelMethod newFromString)
 {
-    FromStringNode* fromStringTmp = GET_FROM_STRING_NODE;
-    while(1) {
-        if(fromStringTmp->next) {
-            fromStringTmp = fromStringTmp->next;
-        }
-        else {
-            fromStringTmp->next = new FromStringNode(newFromString);
-            break;
-        }
-    }
+    fromStringMethods.push_back (newFromString);
 }
 
+        
+} // namespace log4cplus
+} // end namespace dcmtk
